![](https://github.com/libretime/website/blob/main/static/img/logo-512px.png)

[![Financial Contributors on Open Collective](https://opencollective.com/libretime/all/badge.svg?label=financial+contributors)](https://opencollective.com/libretime)

LibreTime makes it easy to run your own online or terrestrial radio station. It
is a community managed fork of the AirTime project.

It is managed by a friendly inclusive community of stations from around the
globe that use, document and improve LibreTime. Join us in fixing bugs and in
defining how we manage the codebase going forward.

We are currently ramping up development on this repository.

Check out the [documentation](https://libretime.org) for more information and
start broadcasting!

Please note that LibreTime is released with a [Contributor Code
of Conduct](https://github.com/libretime/organization/blob/main/CODE_OF_CONDUCT.md).
By participating in this project you agree to abide by its terms.

Please submit enhancements, bug-fixes or comments via GitHub.

## Development Process

The LibreTime follows the standardized [Collective Code Construction
Contract (C4)](https://rfc.zeromq.org/spec:42/C4/). Its abstract is
provided here.

> C4 provides a standard process for contributing, evaluating and
> discussing improvements on software projects. It defines specific
> technical requirements for projects like a style guide, unit tests,
> git and similar platforms. It also establishes different personas
> for projects, with clear and distinct duties. C4 specifies a process
> for documenting and discussing issues including seeking consensus
> and clear descriptions, use of "pull requests" and systematic reviews.

The full text of the contract is licensed under the GPL and available at
the above link courtesy of the [ZeroMQ community](https://zeromq.org/).

## Support

To get support for any questions or problems you might have using the software
we have a forum at [discourse.libretime.org](https://discourse.libretime.org).
We are moving towards using the forum to provide community support and reserving
the github issue queue for confirmed bugs and well-formed feature requests.

You can also contact us through our [Mattermost instance](https://chat.libretime.org)
where you can talk with other users and developers.

## Contributors

### Code Contributors

This project exists thanks to all the people who [contribute](CONTRIBUTING.md).

### Financial Contributors

Become a financial contributor and help us sustain our community on
[OpenCollective](https://opencollective.com/libretime/contribute).

#### Individuals

<a href="https://opencollective.com/libretime">
    <img src="https://opencollective.com/libretime/individuals.svg?width=890">
</a>

#### Organizations

[Support](https://opencollective.com/libretime/contribute) this project with
your organization. Your logo will show up here with a link to your website.

<a href="https://opencollective.com/libretime/organization/0/website">
    <img src="https://opencollective.com/libretime/organization/0/avatar.svg">
</a>
<a href="https://opencollective.com/libretime/organization/1/website">
    <img src="https://opencollective.com/libretime/organization/1/avatar.svg">
</a>
<a href="https://opencollective.com/libretime/organization/2/website">
    <img src="https://opencollective.com/libretime/organization/2/avatar.svg">
</a>
<a href="https://opencollective.com/libretime/organization/3/website">
    <img src="https://opencollective.com/libretime/organization/3/avatar.svg">
</a>
<a href="https://opencollective.com/libretime/organization/4/website">
    <img src="https://opencollective.com/libretime/organization/4/avatar.svg">
</a>
<a href="https://opencollective.com/libretime/organization/5/website">
    <img src="https://opencollective.com/libretime/organization/5/avatar.svg">
</a>

## License

LibreTime is free software: you can redistribute it and/or
modify it under the terms of the GNU Affero General Public
License as published by the Free Software Foundation,
version 3 of the License.

## Copyright

Copyright (c) 2011-2017 Sourcefabric z.ú.

Copyright (c) 2017-2022 LibreTime Community

Please refer to the [LEGACY](./LEGACY.md) file for more information.
