---
title: Administrator manual
---

Welcome to the **LibreTime administrator manual**, you should find guides and references to setup and configure LibreTime.

:::caution

This documentation assumes that you:

- have basic understanding of command line interfaces,
- have a basic understanding of networking.

:::

:::tip

Before following any steps, be sure that your system is up-to-date.

:::

## Install and configure

- [:rocket: Install LibreTime](./setup/install.md)
- [:arrow_up: Upgrade from a previous install](./setup/upgrade.md)
- [:airplane_arriving: Migrate from Airtime](./setup/migrate-from-airtime.md)
- [:gear: Configure your installation](./setup/configuration.md)
- [:lock: Put your installation behind a reverse proxy](./setup/reverse-proxy.md)

## Advanced

- [:warning: Setup automated backups](./backup.md)
- [:heavy_check_mark: Use a custom authentication system](./custom-authentication.md)
