---
title: LibreTime 3.0.0 alpha 9
---

import ReleaseHead from './\_release-head.md';

<ReleaseHead date="2021-01-05" version="3.0.0-alpha.9"/>

## :sparkling_heart: Contributors

The LibreTime project wants to thank the following contributors for contributing to this release:

- @caveman99
- @codenift
- @farggus
- glibloc
- @hairmare
- @jeromelebleu
- @kmahelona
- @monkeywithacupcake
- @Numerico
- @paddatrapper
- @q84fh
- @rjhelms
- @Robbt
- @samkitk
- @teotikalki
- @valerio
- @xabispacebiker
- @zklosko

## :rocket: Features

- Display artwork from ID3 tags if available
- Expose track metadata or artwork in new API endpoint
- "Track Type" feature to classify tracks for auto DJ
- support liquidsoap versions 1.1.1, 1.3.x and 1.4.x out of the box
- Improved French translation
- Updated jquery.cookie to js.cookie
- `forceSSL` config to support TLS on non default ports
- macOS Catalina support for Vagrant
- CentOS 8 Support
- Installer creates a secure icecast password on first run
- Support Multipass as an alternative to Vagrant dev environments

## :bug: Bug fixes

- Fix using outro playlist in "repeat until full" smartblock
- Switch to reliable message consumption to prevent RabbitMQ connections getting dropped side-effects
- Replace absolute css and js URLs with relative URLs
- remove legacy upstream conversion tracking, provisioning, and billing code
- disabled version notification to avoid confusion, users can check current version in Settings > Status.
- Swap out MusesPlayer for HTML5Player for playout
- Make lots of untranslatable strings translatable

## :warning: Known issues

The following issues may need a workaround for the time being. Please search the [issues](https://github.com/libretime/libretime/issues) before reporting problems not listed below.

### Installer Issues

The installer is generally a bit unstable, we hope to be able to offer some reasonable packages at some point. Some of the GUI driven parts before the first login are also in a somewhat questionable state.

For now the installer distro selection is pretty good at auto detecting your os and usually does an ok job depending on your distro. You should usually not need to pass a --distribution and --release parameter, those are still supported for the time being but their use isn't recommended.

The UI works best if you don't use it in an opinionated fashion and change just the bare minimal.

If you want to skip the installer GUI completely you can configure LibreTime using `airtime_mvc/build/airtime.example.conf` as an template. Due to some python/PHP differences you must remove all comments from the example to use it 😞. You'll also have to create some folder structures manually and check if the music dir got properly created directly in the database. Referencing a second `install -fiap` install on a non productive system for reference can help with this type of bootstrap.
f

### Media-Monitor config needs manual removing

If you are using the `install` script you should most likely remove the `[media-monitor]` config section from your `/etc/airtime/airtime.conf` file to ensure you don't run into the problems described in
https://github.com/libretime/libretime/issues/450. We recommend you do this before running the update since there are no known LibreTime releases that depend on the config value.

### Outdated silan reports unreliable cue in/out information

Out of the box the installer installs a broken, outdated version of silan (0.3.2) on some Ubuntu 16.04. CentOS doesn't have upstream packages and you may either install from source or use the [0.3.3 packages](https://github.com/radiorabe/centos-rpm-silan) from [RaBe APEL](https://build.opensuse.org/project/show/home:radiorabe:audio).

Check your version of silan by running `silan --version`. This should report `0.3.3` or higher. If not please see the [Silan Installation](https://github.com/libretime/libretime/wiki/Silan-Installation) wiki page for more details & workarounds.

tldr: **[Silan Installation](https://github.com/libretime/libretime/wiki/Silan-Installation)**

### No watched folder support

Currently LibreTime doesn't support watching folders. Uploading files through the web interface works fine and can be automated via a REST API. Re-implementing watched folder support is on the roadmap. Please consider helping out with the code to help speed things along if you want to use the feature.

### No line in support

This feature went missing from LibreTime due to the fact that we based our code off of the saas-dev branch of legacy upstream and support for recording hasn't been ported to the new airtime analyzer ingest system. #42 currently tracks the progress being made on line in recording.

### Playout won't work if locale is missing

Some minimal OS installs don't have a default locale configured. This only seems to affect some VPS installs as they often don't have a locale setup in the default images provided.

You can set up the locale using a combination of the following commands. You might also want to consult the documentation of your VPS provider as it may contain an official way to set up locales when provisioning a VPS.

```bash
# Set locale using systemds localectl
localectl set-locale LANG="en_US.utf8"
```

These instructions don't seem to work on all Debian based distros so you might need to use `update-locale` as follows.

```bash
#Purge all locales but en_US.UTF-8
sudo locale-gen --purge en_US.UTF-8
#Populate LANGUAGE=
sudo update-locale LANGUAGE="en_US.UTF-8"
```

### Lack of i18n toolchain is disturbing

Some translations might miss the tarball. They didn't get lost, but the build chain needs fixing. Work is in #301 and additional work is needed as it has become clear that we probably want to support bidirectional translation syncing with zanata.
