---
title: LibreTime 3.0.0
---

import ReleaseHead from './\_release-head.md';

<ReleaseHead date='2022-10-10' version='3.0.0'/>

## :sparkling_heart: Contributors

The LibreTime project wants to thank the following contributors for authoring PRs to this release:

- @jooola
- @paddatrapper

## :bug: Bug fixes

- clean exit by catching keyboard interrupt ([#2206](https://github.com/libretime/libretime/issues/2206))
- **legacy:** missing plupload uk_UA translation
- **legacy:** jquery i18n translations for plupload
- **legacy:** gracefully handle missing asset checksum
- disable some systemd security features on bionic ([#2219](https://github.com/libretime/libretime/issues/2219))

## :warning: Known issues

The following issues may need a workaround for the time being. Please search the [issues](https://github.com/libretime/libretime/issues) before reporting problems not listed below.

### Missing AAC encoder for Liquidsoap

AAC streams aren't working out of the box because the [current distributions packages of Liquidsoap are lacking a AAC encoder](https://github.com/libretime/libretime/issues/2184). If you need AAC streams, you need to [install Liquidsoap from a different source](https://www.liquidsoap.info/doc-1.4.4/install.html).

### On Ubuntu Bionic, analyzing some FLAC files fails

[On Ubuntu Bionic, analyzing some FLAC files fails with `UnplayableFileError`](https://github.com/libretime/libretime/issues/2218) because of an upstream bug in Liquidsoap. If you encounter this, you should [upgrade to a more recent distribution version](../developer-manual/development/releases.md#distributions-releases-support).
